freeslot(
"S_WORK_STND",
"S_WORK_WALK1",
"S_WORK_WALK2",
"S_WORK_WALK3",
"S_WORK_WALK4",
"S_WORK_EXCLM1",
"S_WORK_RUN1",
"S_WORK_RUN2",
"S_WORK_RUN3",
"S_WORK_RUN4",
"S_WORK_D1",
"S_WORK_D2",
"S_WORK_D3",
"S_WORK_D4",
"S_WORK_JUMP1",
"S_WORK_JUMP2",
"S_PLANEXCLA1",
"S_PLANEXCLA2",
"SPR_WRWK",
"SPR_PLEX",
"MT_WORKER",
"MT_PLANEXCLAMATION",
"sfx_ripwrk",
"MT_SPINNYWORKER", 
"SPR_DEWR", 
"S_WORK_BOUNCE")

sfxinfo[sfx_ripwrk].caption = "Hat Bonk"

states[S_WORK_STND] = {SPR_WRWK, B, 5, A_Look, 0, 0, S_WORK_STND}

states[S_WORK_WALK1] = {SPR_WRWK, A, 3, A_Chase, 0, 0, S_WORK_WALK2}

states[S_WORK_WALK2] = {SPR_WRWK, B, 3, A_Chase, 0, 0, S_WORK_WALK3}

states[S_WORK_WALK3] = {SPR_WRWK, C, 3, A_Chase, 0, 0, S_WORK_WALK4}

states[S_WORK_WALK4] = {SPR_WRWK, B, 3, A_Chase, 0, 0, S_WORK_WALK1}

states[S_WORK_EXCLM1] = {SPR_WRWK, E, 15, A_BunnyHop, 5, 0, S_WORK_RUN1}

states[S_WORK_RUN1] = {SPR_WRWK, F, 1, A_Chase, 0, 0, S_WORK_RUN2}

states[S_WORK_RUN2] = {SPR_WRWK, G, 1, A_Chase, 0, 0, S_WORK_RUN3}

states[S_WORK_RUN3] = {SPR_WRWK, H, 1, A_Chase, 0, 0, S_WORK_RUN4}

states[S_WORK_RUN4] = {SPR_WRWK, G, 1, A_Chase, 0, 0, S_WORK_RUN1}

states[S_WORK_JUMP1] = {SPR_WRWK, G, 2, A_FaceTarget, 7, 5, S_WORK_JUMP2}

states[S_WORK_JUMP2] = {SPR_WRWK, I, 28, A_BunnyHop, 7, 10, S_WORK_RUN1}

states[S_WORK_D1] = {SPR_DEWR, A, 1, A_PlaySound, sfx_ripwrk, 0, S_WORK_D2}

states[S_WORK_D2] = {SPR_DEWR, A, 1, A_SetObjectFlags, MF_NOCLIP|MF_NOCLIPHEIGHT, 0, S_WORK_D3}

states[S_WORK_D3] = {SPR_DEWR, A, 1, A_BunnyHop, 10, 0, S_WORK_D4}

states[S_WORK_D4] = {SPR_DEWR, FF_ANIMATE|A, 52, None, 3, 3, S_NULL}

mobjinfo[MT_WORKER] = {
	doomednum = 2022,
	spawnstate = S_WORK_STND,
	spawnhealth = 1,
	seestate = S_WORK_WALK1,
	deathstate = S_WORK_D1,
	deathsound = sfx_none,
	speed = 6,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	mass = 100,
	damage = 0,
	activeSound = sfx_None,
	flags = MF_ENEMY|MF_SPECIAL|MF_SHOOTABLE
}

mobjinfo[MT_SPINNYWORKER] = {
	doomednum = 3099,
	spawnstate = S_WORK_BOUNCE,
	spawnhealth = 9999999,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	mass = 100,
	damage = 0,
	activesound = sfx_None
}

mobjinfo[MT_PLANEXCLAMATION] = {
	doomednum = -1,
	spawnstate = S_PLANEXCLA1,
	spawnhealth = 9999999,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	damage = 0,
	flags = MF_NOGRAVITY,
	activesound = sfx_None
}

states[S_PLANEXCLA1] = {SPR_PLEX, FF_ANIMATE|A, 8, nil, 4, 2, S_PLANEXCLA2}

states[S_PLANEXCLA2] = {SPR_PLEX, E, 10, nil, 0, 0, S_NULL}

states[S_WORK_BOUNCE] = {SPR_DEWR, FF_ANIMATE|A, 52, nil, 3, 3, S_WORK_BOUNCE}

addHook("MobjThinker", function(mobj)
    if leveltime % 2
    mobj.rollangle = $ + FixedAngle(4*FRACUNIT)
	end
	if P_IsObjectOnGround(mobj)
	   P_SetObjectMomZ(mobj, 20*FRACUNIT, false)
	   S_StartSound(mobj, 442)
	end
end, MT_SPINNYWORKER)

addHook("MobjThinker", function(mobj)
    if mobj.jumping == nil then mobj.jumping = false end
    if mobj.target == nil then return end
    if not mobj.hasseen and R_PointToDist2(mobj.x, mobj.y, mobj.target.x, mobj.target.y) <= 512*FRACUNIT 
	   mobj.state = S_WORK_EXCLM1
	   mobj.hasseen = true
	end
    if mobj.state == S_WORK_EXCLM1
	   if mobj.exclamation == false
	      P_SpawnMobjFromMobj(mobj, 0, 0, 64*FRACUNIT, MT_PLANEXCLAMATION)
		  S_StartSound(mobj, sfx_alarm)
		  mobj.exclamation = true
	   end
	else
	   mobj.exclamation = false
	end
	if mobj.hasseen == true and mobj.jumping == false and R_PointToDist2(mobj.x, mobj.y, mobj.target.x, mobj.target.y) <= 256*FRACUNIT and P_IsObjectOnGround(mobj) == true
	   mobj.state = S_WORK_JUMP1
	   mobj.jumping = true
	end
	if mobj.jumping == true and mobj.eflags & MFE_JUSTHITFLOOR
	   mobj.jumping = false
	end
end, MT_WORKER)